import com.ibm.bsf.BSFManager;
import com.ibm.bsf.BSFEngine;
import com.ibm.bsf.BSFException;

/**
 * This is a sample code to illustrate how to use Pnuts
 * from Bean Scripting Framework. 
 *
 * http://oss.software.ibm.com/developerworks/opensource/bsf/
 */
public class Sample {
    public static void main(String args[]){
	BSFManager.registerScriptingEngine("pnuts", "pnuts.ext.PnutsBSFEngine", new String[]{"pnut"});
	BSFManager mgr = new BSFManager();
	try {
	    BSFEngine p = mgr.loadScriptingEngine("pnuts");

	    p.eval("startup", 0, 0, "load(`init`)");

	    // declare a Bean
	    mgr.declareBean("myFrame", new java.awt.Frame("mine"), java.awt.Frame.class);

	    p.eval("test", 0, 0, "println(`myFrame`)");

	    // undeclare a Bean
	    mgr.undeclareBean("myFrame");

	    p.eval("test2", 0, 0, "println(defined(`myFrame`))");

	    // call Object.hashCode()
	    System.out.println(p.call(new Object(), "hashCode", new Object[]{}));
	} catch (BSFException e){
	    e.printStackTrace();
	}
    }
}
